/* The Simple Railway Crossing in Spin, revisited.
 * This version features a command channel between the train
 * and the gate. It is still unsafe.
 */

mtype = { appr, xing, lvng, away }

mtype = { gate_open, gate_close, gate_closed }

mtype = { open, clos } 

mtype gate_state= open;
mtype car_state= away;
mtype train_state= away;

proctype Gate(chan cmd) {  
  do
  :: gate_state == open -> 
     if 
     :: cmd ? gate_close; gate_state= clos; 
     fi
  :: gate_state == clos -> 
     if 
     :: cmd ? gate_open; gate_state= open
     fi
  od                 
}

proctype Train(chan gate_cmd) {
  do
  :: train_state == away -> gate_cmd ! gate_close; train_state= appr;
  :: train_state == appr && gate_state == clos -> train_state= xing;
  :: train_state == xing -> train_state= lvng; gate_cmd ! gate_open;
  :: train_state == lvng -> train_state = away;
  od
}

proctype Car() {
  do 
  :: car_state == away -> car_state= appr;
  :: car_state == appr && gate_state == open -> car_state = xing;
  :: car_state == xing && gate_state == open -> car_state= lvng;
  :: car_state == lvng -> car_state= away;
  od
}
  


init {
  chan cmd= [1] of { mtype };

  run Train(cmd);
  run Gate(cmd);
  run Car();
}

ltl safety { [] (! (car_state == xing && train_state == xing)) } 
ltl train_available { [] (train_state == appr -> <> (train_state == lvng)) }
